--Command.System.Strict()

local addonInfo, addonTable = ...
if not addonTable.KBB then addonTable.KBB = {} end
local KBB = addonTable.KBB

KBB.defaults = {
	group = {
		unit = "player",
		name = "kbbgroup",
		watchType = "buff",
		filterType = "blacklist",
		buffColor = {r = 51, g = 51, b = 153},
		debuffColor = {r = 0153, g = 25, b = 25} ,
		fontColor = {r = 255, g = 255, b = 255},
		debuffFontColor = { r = 255, g = 255, b = 255},               -- 2.05
		backgroundAlpha = 76,
		backgroundColor = {r = 0, g = 0, b = 0},   -- 2.05
		backgroundUsesSameColor = true,            -- 2.05
		barHeight = 20,
		barWidth = 250,
		barLayout = {
			textPos = {anchorFrom = "CENTERLEFT", anchorTo = "CENTERLEFT", x = 0, y = 0},
			iconPos = {anchorFrom = "CENTERRIGHT", anchorTo = "CENTERLEFT", x = 0, y = 0},
			timerPos = {anchorFrom = "CENTERRIGHT", anchorTo = "CENTERRIGHT", x = 0, y = 0},
			stackPos = {anchorFrom = "CENTERRIGHT", anchorTo = "CENTERLEFT", x = -10, y = 0},
			},
		iconLayout = {
			textPos = {anchorFrom = "CENTERTOP", anchorTo = "CENTERBOTTOM", x = 0, y = 0},
			},
		timerFontSize = 14,
		textFontSize = 14,		
		stackFontSize = 14,
		spacing = 4,
		stackMargin = 10,
		growth = "up",
		position = {x = 0, y = 0,},
		filters = {},
		cancelClick = false,
		sorts = false,
		sortOrder = "asc",
		},	
	settings = {                            -- 2.05
		on = true,                          -- 2.05
		minimapButton = true,              -- 2.05
		minimapButtonAngle = 223,			-- 2.05
		minimapButtonOffset = -33,			-- 2.05
		minimapButtonSize = 30,
		useNativeTooltip = true,			-- 2.05
	}
}

KBB.throttle = 0.2
KBB.callsThrottle = 8.0

KBB.units = {
		["player"] = true, 
		["player.target"] = true, 
		["player.pet"] = true, 
		["focus"] = true
		}
		
KBB.watchTypes = {
		["buff"] = true, 
		["debuff"] = true,
		}
		
KBB.filterTypes = {
		["whitelist"] = true,
		["blacklist"] = true,
		}

KBB.filters = {
	-- allowed operators for filters
	n = {"=", "~="},
	t = {">", "<", ">=", "<=", "==nil", "!=nil"}
}

KBB.filterOps = {
	-- order matters
	-- by string length, descending
	"==nil",
	">=",
	"<=",
	"~=",
	">",
	"<",
	"="
}

KBB.growth = {
	["up"] = true,
	["down"] = true,
}

KBB.on = true

KBB.debugMode = false

KBB.showAnchors = false
KBB.anchorColor = {0.3, 0.3, 0.3, 1 }

KBB.tooltipFontSize = 16
KBB.groups = {}

function KBB.debug(...)
	if KBB.debugMode then
		print("KBB debug:", ...)
	end
end
